﻿using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Core;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.Dispatch
{
    public class ProcessTrafficLight : ISimpleProcess
    {
        private bool firstStart = true;

        public void SimpleProcess()
        {
            var agvDataList = DeviceControl.Instance.Communication.InfoAgvDictionary.Values;

            var configList = ExcelConfig.Instance.AreaConfigList;

            for (int i = 0; i < configList.Count; i++)
            {
                var data = configList[i];
                if (data.TrafficLightId <= 0) continue;

                var agvData = agvDataList.FirstOrDefault(d => d.DataValid && d.Mark > 0 && data.GraphVertexs.Length > 0 && data.GraphVertexs.Contains(d.Mark));

                var result = agvData != null;
                if (data.AgvInArea != result || firstStart || data.ReSetTrafficLight)
                {
                    data.SetTrafficLightTime = DateTime.Now;
                    data.AgvInArea = result;
                    DeviceControl.Instance.SetAlarmLight(data.TrafficLightId, data.AgvInArea ? 1 : 0);

                    //CLog.Instance.TaskLog.WriteInfo($"交通灯{data.TrafficLightId} {data.AgvInArea}");
                }

            }

            firstStart = false;
        }
    }
}
