﻿using DbCommon.BusinessCore.BaseCore;
using DbCommon.Enties.DbModels;
using ProjectManagementSystem.Common.Extenions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.Dispatch
{

    public class SimpleStep
    {
        private LocationPropertyManager locationManager = new LocationPropertyManager();

        public bool StepInStation(CallTask taskData)
        {
            switch (taskData.TemplateName)
            {
                case "默认模板":
                    if (taskData.WarehouseIndex == 0)
                    {
                        //待命点发车
                        taskData.StepRoute = taskData.CurrentWarehouse.GetLocationMember("入库取货路线").ToValue<int>();
                    }
                    else if (taskData.WarehouseIndex == 1)
                    {
                        taskData.StepRoute = taskData.CurrentWarehouse.GetLocationMember("入库放货路线").ToValue<int>();
                    }
                    break;
                default:
                    break;
            }

            return true;
        }

        public bool StepArriveLocation(CallTask taskData, out string msg)
        {
            switch (taskData.TemplateName)
            {
                case "默认模板":
                    if (taskData.WarehouseIndex == 0)
                    {
                        var locationData = locationManager.GetById(taskData.StepLocation);
                        taskData.MaterialId = locationData?.MaterialId;

                        locationData.Status = LocationStatus.Empty;
                        locationData.MaterialId = string.Empty;

                        var result = locationManager.Update(locationData);

                        msg = $"取货{result.ToChineseString()}，{taskData.StepLocation}置空，物料清空，任务带上物料：{taskData.MaterialId}";
                        return result;
                    }
                    else if (taskData.WarehouseIndex == 1)
                    {
                        var locationData = locationManager.GetById(taskData.StepLocation);

                        locationData.Status = LocationStatus.Filled;
                        locationData.MaterialId = taskData.MaterialId;

                        var result = locationManager.Update(locationData);

                        msg = $"放货{result.ToChineseString()}，{taskData.StepLocation}置满，设置物料：{taskData.MaterialId}";
                        return result;
                    }
                    break;
                default:
                    break;
            }

            msg = null;
            return false;
        }

        public bool TaskStarting(CallTask taskData)
        {
            switch (taskData.TemplateName)
            {
                case "默认模板":
                    break;
                default:
                    break;
            }

            return true;
        }

        public bool TaskFinished(CallTask taskData)
        {
            switch (taskData.TemplateName)
            {
                case "默认模板":
                    break;
                default:
                    break;
            }

            return true;
        }
    }
}
