﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.Service
{
    public class Crms
    {
        public static IPmsApi PmsApi { get; private set; }
        public static SWmsApi SWmsApi { get; private set; }
        public static PmsTaskService PmsTaskService { get; private set; }
        static Crms()
        {
            var api = Function.AppSetting.TryGetValue<string>("PmsApi");
            if(string.IsNullOrWhiteSpace(api))
            {
                api = "PmsApi";
            }

            var assemblyName = typeof(PmsApi).Assembly.GetName().Name;
            var nameSpace = typeof(PmsApi).Namespace;

            string fullClassName = $"{nameSpace}.{api}";
            PmsApi = Function.InstanceConstructor.GetInstance<IPmsApi>(assemblyName, fullClassName);

            SWmsApi = new SWmsApi();
            PmsTaskService = new PmsTaskServiceSWms();
        }
    }
}
