﻿using DbCommon.BusinessCore.BaseCore;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.DataCache;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Service;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.TaskBookEvent
{
    public class TaskBookBehavior_63006 : BaseTaskBookBehaviorV2
    {
        public TaskBookBehavior_63006() : base(63006, "检测滚筒无料")
        {
        }

        public override bool TaskBookOperator(TaskData taskDetailInfo, StepData stepInfo)
        {
            try
            {
                var agvDataList1 = Crms.PmsApi.GetAllCarrier();
                if (agvDataList1 == null) return false;
                var agvDataList =  agvDataList1.Where(d => d.Online);
                if(agvDataList == null) return false;
                var agvDataAtStation = agvDataList.FirstOrDefault(d =>d.AgvID== taskDetailInfo.Carrier);
                if (agvDataAtStation == null) return false;
                if(agvDataAtStation.LogicBits.GetBitVaule(9))
                {
                    Log(taskDetailInfo, stepInfo, $"滚筒检测有物料不进行对接");
                    return false;
                }
                Log(taskDetailInfo, stepInfo, $"滚筒检测无物料进行对接");
                return true;
            }
            catch (Exception ex)
            {
                LogException(ex);
            }
            return false;
        }
    }
}

