﻿using DbCommon.BusinessCore.BaseCore;
using HslCommunication;
using ICSharpCode.SharpZipLib.Zip;
using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.Models;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Service;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Web;

namespace ProjectManagementSystem.Common.TaskEvent
{
    public class ProcessCallTask8881 : ICustomProcess
    {
        LocationPropertyManager m_locationManager = new LocationPropertyManager();
        string _呼叫AGV = "呼叫AGV";
        string _二维码 = "二维码(PLC)";
        string _请求下料 = "请求下料(AGV)";
        string _开始下料 = "开始下料(PLC)";
        string _收料完成 = "收料完成(AGV)";
        string _下料完成 = "下料完成(PLC)";
        public void CustomProcess(List<TaskData> taskDataList)
        {
            var FullBoxCallRouteConfigList = ExcelConfig.Instance.RouteConfigList.Where(d => d.WareHouseCode.Contains("满箱上料")).ToList();
            if (FullBoxCallRouteConfigList != null)
            {
                var agvDataList = Crms.PmsApi.GetAllCarrier();
                if (agvDataList != null)
                {
                    foreach (var routeConfig in FullBoxCallRouteConfigList)
                    {
                        bool taskToFullBoxUpLocation = taskDataList != null && taskDataList.Any(p => p.CurrentStepID < 4 && p.StepList != null && p.StepList.Count > 0 && p.StepList[0].WareHouseID == routeConfig.LocationCode);
                        if (!taskToFullBoxUpLocation)
                        {
                            //var agvData = agvDataList?.FirstOrDefault(d => d.Online && (d.Status == 0|| d.Status == 4) && d.GraphVertex == routeConfig.GraphVertex);//|| d.Status == 4
                            //if (agvData != null && routeConfig.GraphVertex > 0)
                            {
                                if (!string.IsNullOrEmpty(routeConfig.PlcIpAddr) && !string.IsNullOrWhiteSpace(routeConfig.PlcIpAddr))
                                {
                                    string tempCallAGVDB = routeConfig.LocationCode.GetPlcTaskAddr(_呼叫AGV);
                                    string tempQRCodeDB = routeConfig.LocationCode.GetPlcTaskAddr(_二维码);
                                    if (!string.IsNullOrEmpty(tempCallAGVDB) && !string.IsNullOrWhiteSpace(tempCallAGVDB))
                                    {
                                        var plc = routeConfig.PlcReadWrite;
                                        OperateResult<Int16> operateResult = plc.ReadInt16(tempCallAGVDB);
                                        OperateResult<string> operateStringResult = plc.ReadString(tempQRCodeDB, 10);
                                        if (operateResult.IsSuccess && operateResult.Content == 1)
                                        {
                                            Log($"{routeConfig.LocationCode}叫料，{tempCallAGVDB}值:1 ");
                                            if (!string.IsNullOrWhiteSpace(operateStringResult.Content) && !string.IsNullOrEmpty(operateStringResult.Content))
                                            {
                                                string QRCode = operateStringResult.Content;
                                                Log($"{routeConfig.LocationCode} 扫码不为空进行下料点匹配，{tempQRCodeDB}值:{QRCode} ");
                                                //if (!ExcelConfig.Instance.BoxCodeDownLocationMatchDict.ContainsKey(QRCode)
                                                //    || string.IsNullOrEmpty(ExcelConfig.Instance.BoxCodeDownLocationMatchDict[QRCode].DownLocation)
                                                //    || string.IsNullOrWhiteSpace(ExcelConfig.Instance.BoxCodeDownLocationMatchDict[QRCode].DownLocation))
                                                //{
                                                //    Log($"{routeConfig.LocationCode} 扫码:{QRCode}为配置下料点，{tempQRCodeDB}值: ");
                                                //}
                                                var goodsList = Crms.SWmsApi.GetAllGoods();

                                                var data = goodsList.FirstOrDefault(d => QRCode.Contains(d.goodsCode));
                                                if (data == null || string.IsNullOrEmpty(data.attribute1) || string.IsNullOrWhiteSpace(data.attribute1))
                                                {
                                                    Log($"{routeConfig.LocationCode} 扫码:{QRCode}未配置下料点 ");
                                                    continue;
                                                }
                                                else
                                                {
                                                    Log($"{routeConfig.LocationCode} 扫码:{QRCode}配置下料点，{data.attribute1} ");
                                                }

                                                if (PmsTaskService.Instance.LocationHasStepTask(routeConfig.LocationCode, out var tasklist))
                                                {
                                                    Log($"{routeConfig.LocationCode} 已存在叫料任务 ");
                                                    continue;
                                                }
                                                //string nextlocation = routeConfig.LocationCode.GetLocationMember("下个工位");
                                                string nextlocation = data.attribute1;
                                                if (string.IsNullOrEmpty(nextlocation) || string.IsNullOrWhiteSpace(nextlocation))
                                                {
                                                    Log($"{routeConfig.LocationCode} 下个工位未配置 ");
                                                }
                                                PmsTaskInfoDto data2 = new PmsTaskInfoDto();
                                                data2.LocationCode = routeConfig.LocationCode;
                                                data2.TargetLocationCode = nextlocation;
                                                //data2.Carrier = agvData.AgvID;
                                                var res2 = PmsTaskService.Instance.TaskAddNoCheck(data2, new string[] { });
                                                if (res2?.code == 20000)
                                                {
                                                    //发出响应
                                                    Thread.Sleep(2000);
                                                }
                                                Log($"添加任务【{data2.TaskID}】结果：{res2.message} 返回代码{res2.code}");

                                            }
                                            //else
                                            //{
                                            //    Log($"{routeConfig.LocationCode} 扫码为空，{tempQRCodeDB}值: ");
                                            //}
                                        }
                                        else
                                        {

                                        }


                                    }
                                }
                            }
                            
                        }
                    }
                }

            }

            var EmptyBoxCallRouteConfigList = ExcelConfig.Instance.RouteConfigList.Where(d => d.WareHouseCode.Contains("空箱上料")).ToList();
            if (EmptyBoxCallRouteConfigList != null)
            {
                foreach (var routeConfig in EmptyBoxCallRouteConfigList)
                {
                    bool taskToEmptyBoxUpLocation = taskDataList != null && taskDataList.Any(p => p.CurrentStepID < 4 && p.StepList != null && p.StepList.Count > 0 && p.StepList[0].WareHouseID == routeConfig.LocationCode);
                    if (!taskToEmptyBoxUpLocation)
                    {
                        if (!string.IsNullOrEmpty(routeConfig.PlcIpAddr) && !string.IsNullOrWhiteSpace(routeConfig.PlcIpAddr))
                        {

                            string tempCallAGVDB = routeConfig.LocationCode.GetPlcTaskAddr(_呼叫AGV);
                            //string tempQRCodeDB = routeConfig.LocationCode.GetPlcTaskAddr(_二维码);
                            if (!string.IsNullOrEmpty(tempCallAGVDB) && !string.IsNullOrWhiteSpace(tempCallAGVDB))
                            {
                                var plc = routeConfig.PlcReadWrite;
                                OperateResult<Int16> operateResult = plc.ReadInt16(tempCallAGVDB);
                                //OperateResult<string> operateStringResult = plc.ReadString(tempQRCodeDB, 10);
                                if (operateResult.IsSuccess && operateResult.Content == 1)
                                {
                                    Log($"{routeConfig.LocationCode}叫料，{tempCallAGVDB}值:1 ");
                                    //if (!string.IsNullOrWhiteSpace(operateStringResult.Content) && !string.IsNullOrEmpty(operateStringResult.Content))
                                    {
                                        //string QRCode = operateStringResult.Content;
                                        //Log($"{routeConfig.LocationCode} 扫码不为空进行下料点匹配，{tempQRCodeDB}值: ");
                                        //if (!ExcelConfig.Instance.BoxCodeDownLocationMatchDict.ContainsKey(QRCode)
                                        //    || string.IsNullOrEmpty(ExcelConfig.Instance.BoxCodeDownLocationMatchDict[QRCode].DownLocation)
                                        //    || string.IsNullOrWhiteSpace(ExcelConfig.Instance.BoxCodeDownLocationMatchDict[QRCode].DownLocation))
                                        //{
                                        //    Log($"{routeConfig.LocationCode} 扫码:{QRCode}为配置下料点，{tempQRCodeDB}值: ");
                                        //}
                                        //var goodsList = Crms.SWmsApi.GetAllGoods();

                                        //var data = goodsList.FirstOrDefault(d => d.goodsCode == QRCode);
                                        //if (data == null || string.IsNullOrEmpty(data.attribute1) || string.IsNullOrWhiteSpace(data.attribute1))
                                        //{
                                        //    Log($"{routeConfig.LocationCode} 扫码:{QRCode}为配置下料点，{tempQRCodeDB}值: ");
                                        //}

                                        if (PmsTaskService.Instance.LocationHasStepTask(routeConfig.LocationCode, out var tasklist))
                                        {
                                            Log($"{routeConfig.LocationCode} 已存在叫料任务 ");
                                            continue;
                                        }
                                        string nextlocation = routeConfig.LocationCode.GetLocationMember("下个工位");
                                        
                                        if (string.IsNullOrEmpty(nextlocation) || string.IsNullOrWhiteSpace(nextlocation))
                                        {
                                            Log($"{routeConfig.LocationCode} 下个工位未配置 ");
                                        }
                                        string[] nextLocations = nextlocation.ToValueArray<string>();
                                        bool[] sAllowArray = new bool[nextLocations.Length];
                                        bool[] sNoTaskArray = new bool[nextLocations.Length];
                                        bool[] sNoAgvArray = new bool[nextLocations.Length];
                                        StringBuilder stringBuilder = new StringBuilder();
                                        for (int i = 0; i < nextLocations.Length; i++)
                                        {
                                            var location = nextLocations[i];
                                            sAllowArray[i] = CheckAllowEnter(location);
                                            sNoTaskArray[i] = CheckNoTask(location, null, taskDataList);
                                            sNoAgvArray[i] = CheckNoAgv(location);

                                            stringBuilder.Append($"{location} 允许进入{sAllowArray[i]} 无任务{sNoTaskArray[i]} 无小车{sNoAgvArray[i]}; ");
                                        }
                                        string nextLocation = null;
                                        for (int i = 0; i < nextLocations.Length; i++)
                                        {
                                            var location = nextLocations[i];

                                            if (sAllowArray[i] && sNoTaskArray[i] && sNoAgvArray[i])
                                            {
                                                nextLocation = location;
                                                break;
                                            }
                                        }
                                        if (string.IsNullOrEmpty(nextLocation))
                                        {
                                            Log($"{nextlocation} 中未找到可以分配的工位 【分配信息{stringBuilder}】,暂时先选择配置第一个下料点:{nextLocations[0]}");
                                            nextlocation = nextLocations[0];
                                        }
                                        else
                                        {
                                            Log($"{nextlocation} 中已找到可以分配的工位 {nextLocation} 【分配信息{stringBuilder}】");
                                            nextlocation = nextLocation;
                                        }

                                        PmsTaskInfoDto data2 = new PmsTaskInfoDto();
                                        data2.LocationCode = routeConfig.LocationCode;
                                        data2.TargetLocationCode = nextlocation;//ExcelConfig.Instance.BoxCodeDownLocationMatchDict[QRCode].DownLocation
                                        //data2.Carrier = agv1.AgvID;
                                        //data2.temp = "KBK返空车";
                                        var res2 = PmsTaskService.Instance.TaskAddNoCheck(data2, new string[] { });
                                        if (res2?.code == 20000)
                                        {
                                            //发出响应
                                            Thread.Sleep(2000);
                                        }
                                        Log($"添加任务【{data2.TaskID}】结果：{res2.message} 返回代码{res2.code}");

                                    }
                                    //else
                                    //{
                                    //    Log($"{routeConfig.LocationCode} 扫码为空，{tempQRCodeDB}值: ");
                                    //}
                                }
                                else
                                {

                                }


                            }
                        }
                    }
                }

            }

        }


        public bool CheckIsRepair(string locationcode)
        {
            var routeConfig = ExcelConfig.Instance.GetRouteConfig(locationcode);
            var plcaddress = locationcode.GetLocationMember("PLC返修");
            if (plcaddress != null && routeConfig.PlcReadWrite != null)
            {
                var result = routeConfig.PlcReadWrite.ReadBool(plcaddress);
                if (result.IsSuccess && result.Content)
                {
                    Log($"收到返修信号{locationcode}，下发返修任务");
                    return true;
                }
            }
            return false;
        }
        protected virtual bool CheckAllowEnter(string location)
        {
            //string agvRequestEnter = location.GetLocationMember("AGV请求进入");
            //if (!string.IsNullOrEmpty(agvRequestEnter))
            //{
            //    //如果有AGV请求，那任务所有工位都可以进入
            //    return true;
            //}

            string plcAllowEnter = location.GetLocationMember("PLC允许进入");
            if (string.IsNullOrEmpty(plcAllowEnter))
            {
                return true;
            }

            var config = ExcelConfig.Instance.GetRouteConfig(location);
            if (config == null
            || config.PlcReadWrite == null
            )//|| config.PlcConnected == false
            {
                return false;
            }

            OperateResult<Int16> read = config.PlcReadWrite.ReadInt16(plcAllowEnter);
            return read.IsSuccess && read.Content==1;
        }

        private bool CheckNoTask(string location, TaskData taskDetailInfo, List<TaskData> taskDataList)
        {
            //查找结束点是当前工位的任务
            var taskDataFind = taskDataList.FirstOrDefault(d =>
            {
                //不算自身任务
                //if (d.TaskID == taskDetailInfo.TaskID) return false;

                var step = d.StepList?.OrderBy(s => s.StepID);
                var firstPos = step?.First()?.WareHouseID;
                var lastPos = step?.Last()?.WareHouseID;

                //不算放行任务
                if (firstPos != lastPos)
                {
                    if (firstPos == location)
                    {
                        return false;
                    }
                }

                //正在执行步骤的位置
                var currentPos = d.GetCurrentStepInfo()?.WareHouseID;
                return currentPos == location;
            });

            return taskDataFind == null;
        }

        private bool CheckNoAgv(string location)
        {
            var ignoreCheck = location.GetLocationMember("忽略检查工位AGV").ToValue<bool>();
            if (ignoreCheck)
            {
                return true;
            }

            var sDict = PackControl.Instance.StationDictionary;
            return sDict.TryGetValue(location, out var station) && !station.区域有Agv;
        }

        string lastMsg = "";
        public void Log(string msg, bool isDebug = false)
        {
            if (msg == lastMsg) return;

            lastMsg = msg;
            if (isDebug)
                CLog.Instance.TaskLog.WriteDebug(msg);
            else
                CLog.Instance.TaskLog.WriteInfo(msg);
        }
    }
}

