﻿using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Device.CommandCallback;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.TaskEvent
{
    public class ProcessRollerHxQuery : ICustomProcess
    {
        public ProcessRollerHxQuery()
        {
            var configList = ExcelConfig.Instance.RouteConfigList;
            var infoDict = DeviceControl.Instance.Communication.InfoRollerHxDictionary;

            for (int i = 0; i < configList.Count; i++)
            {
                var config = configList[i];
                var rollerIp = config.LocationCode.GetLocationMember("滚筒台IP地址");

                if (config.RollerID > 0
                    && !string.IsNullOrWhiteSpace(rollerIp))
                {
                    if (!infoDict.TryGetValue(config.RollerID, out var _))
                    {
                        var info = new InfoRollerHx();
                        info.DeviceId = config.RollerID;
                        info.RemoteEndPoint = rollerIp;
                        infoDict.AddOrUpdate(config.RollerID, info, (key, value) => info);
                    }
                }
            }
        }

        public void CustomProcess(List<TaskData> taskDataList)
        {
            var configList = ExcelConfig.Instance.RouteConfigList;
            for (int i = 0; i < configList.Count; i++)
            {
                var config = configList[i];
                var rollerIp = config.LocationCode.GetLocationMember("滚筒台IP地址");

                if (config.RollerID > 0
                    && !string.IsNullOrWhiteSpace(rollerIp))
                {
                    DeviceControl.Instance.RollerHxQuery(config.RollerID);
                }
            }
        }
    }
}
