﻿using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.Models;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Service;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.TaskEvent
{
    public class ProcessSWmsTask : ICustomProcess
    {
        public void CustomProcess(List<TaskData> taskDataList)
        {
            TaskAdd("货架缓存", "货架备料", "空料车");
            TaskAdd("货架缓存", "人工下料", "满料车");
        }

        private void TaskAdd(string startWarehouse, string endWarehouse, string startMaterialId = null)
        {
            var location1 = Crms.SWmsApi.GetLocationIdOut(startWarehouse, startMaterialId);
            if (string.IsNullOrWhiteSpace(location1))
            {
                return;
            }
            var location2 = Crms.SWmsApi.GetLocationIdIn(endWarehouse);
            if (string.IsNullOrWhiteSpace(location2))
            {
                return;
            }

            PmsTaskInfoDto data = new PmsTaskInfoDto();
            data.WareHouseCode = startWarehouse;
            data.MaterialId = startMaterialId;
            data.TargetWareHouseCode = endWarehouse;

            var res = Crms.PmsTaskService.TaskAdd(data);

            var result = res.code == 20000;
            CLog.Instance.TaskLog.WriteInfo($"TaskAdd {result.ToChineseString()} {res.message}");
        }
    }
}
