﻿using DbCommon.BusinessCore.BaseCore;
using DbCommon.Enties.DbModels;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.Models;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Service;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.TaskEvent
{
    public class ProcessWmsTask : ICustomProcess
    {
        private LocationPropertyManager locationManager = new LocationPropertyManager();
        public void CustomProcess(List<TaskData> taskDataList)
        {
            if (taskDataList.Count >= 1) return;

            TaskAdd("WarehouseAB", "Passroom", "EmptyTrolley");
            TaskAdd("WarehouseCD", "Passroom", "EmptyTrolley");

            TaskAdd("SecPack", "WarehouseAB", "EmptyTrolley");
            TaskAdd("SecPack", "WarehouseCD", "EmptyTrolley");
        }

        private void TaskAdd(string startWarehouse, string endWarehouse, string startMaterialId = null)
        {
            var location1 = locationManager.QueryLocation_Out(startWarehouse, LocationStatus.Filled, startMaterialId);
            if (string.IsNullOrWhiteSpace(location1))
            {
                return;
            }
            var location2 = locationManager.QueryLocation_In(endWarehouse);
            if (string.IsNullOrWhiteSpace(location2))
            {
                return;
            }

            PmsTaskInfoDto data = new PmsTaskInfoDto();
            data.WareHouseCode = startWarehouse;
            data.MaterialId = startMaterialId;
            data.TargetWareHouseCode = endWarehouse;

            var res = Crms.PmsTaskService.TaskAdd(data);

            var result = res.code == 20000;
            CLog.Instance.TaskLog.WriteInfo($"TaskAdd {result.ToChineseString()} {res.message}");
        }
    }
}
