﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Language
{
    public class ResourceService
    {
        public event Action<string> CultureChanged;

        private ResourceService()
        {
        }

        private static ResourceService _current = new ResourceService();
        public static ResourceService Current => _current;


        private Langs resource = new Langs();
        public Langs Langs => resource;

        public static string GetString(string name)
        {
            return Langs.ResourceManager.GetString(name, Langs.Culture);
        }

        public void ChangeCulture(string name)
        {
            var cultureInfo = CultureInfo.GetCultureInfo(name);

            System.Threading.Thread.CurrentThread.CurrentUICulture = cultureInfo;
            System.Threading.Thread.CurrentThread.CurrentCulture = cultureInfo;
            Langs.Culture = cultureInfo;

            CultureChanged?.Invoke(name);
        }
    }
}
