﻿using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Models;
using System;
using System.Web.Http;
using System.Web.Http.Results;
using System.Linq;
using System.Collections.Generic;
using System.Net.Http;
using System.IO;
using System.Net.Http.Headers;
using System.Net;
using ProjectManagementSystem.Common.Core;
using System.Runtime.CompilerServices;
using System.Web.Http.Description;
using ProjectManagementSystem.WebApi.Filters;
using ProjectManagementSystem.Common.Service;

namespace ProjectManagementSystem.WebApi.Controller
{
    [ValidateModel]
    public class PmsController : ApiController
    {
        private PmsTaskService taskService = Crms.PmsTaskService;

        [GlobalActionFilter]
        [HttpPost]
        public WebMgrResponse TaskAdd([FromBody] PmsTaskInfoDto dataDto)
        {
            return taskService.TaskAdd(dataDto);
        }

        [GlobalActionFilter]
        [HttpPost]
        public WebMgrResponse TaskAppointment([FromBody] PmsTaskInfoDto dataDto)
        {
            return taskService.TaskAppointment(dataDto);
        }

        [GlobalActionFilter]
        [HttpPost]
        public WebMgrResponse TaskTransport([FromBody] RequestTaskTransport taskInfo)
        {
            return taskService.TaskTransport(taskInfo);
        }

        [GlobalActionFilter]
        [HttpPost]
        public WebMgrResponse TaskCancel([FromBody] RequestTaskCancel data)
        {
            return taskService.TaskCancel(data);
        }

        [GlobalActionFilter]
        [HttpPost]
        public WebMgrResponse ReleaseAgv([FromBody] ReleaseAgvDto data)
        {
            return taskService.ReleaseAgv(data);
        }

        [HttpGet]
        public WebMgrResponse GetLocationProperty([FromUri] LocationPropertyQueryDto data)
        {
            return taskService.GetLocationProperty(data);
        }

        [GlobalActionFilter]
        [HttpPost]
        public WebMgrResponse UpdateLocationProperty([FromBody] LocationPropertyUpdateDto data)
        {
            return taskService.UpdateLocationProperty(data);
        }

        [GlobalActionFilter]
        [HttpPost]
        public WebMgrResponse AreaTrafficIn([FromBody] AreaTrafficDto data)
        {
            return taskService.AreaTrafficIn(data);
        }

        [GlobalActionFilter]
        [HttpPost]
        public WebMgrResponse AreaTrafficOut([FromBody] AreaTrafficDto data)
        {
            return taskService.AreaTrafficOut(data);
        }
    }
}
