﻿using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Dispatch;
using ProjectManagementSystem.WebApi.Service;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace ProjectManagementSystem.Enterance
{
    public class DispatchSystem
    {
        public DispatchSystem()
        {
            if (ExcelConfig.Instance == null)
            {
                KillCurrentProcess("Excel配置加载失败");
                return;
            }

            if (!SystemInitialize.InitDataSource())
            {
                KillCurrentProcess("数据库初始化失败");
                return;
            }

            //if (RouteCalled.Instance == null)
            //{
            //    KillCurrentProcess("初始化RouteCalled失败");
            //    return;
            //}

            if (PlcControl.Instance == null)
            {
                KillCurrentProcess("初始化Plc失败");
                return;
            }

            if (DeviceControl.Instance == null)
            {
                KillCurrentProcess("初始化DeviceControl失败");
                return;
            }

            if (!WebApiServerHost.Instance.StartServer())
            {
                KillCurrentProcess("初始化WebApi失败");
                return;
            }

            SystemInitialize.InitWMS();

            if (SimpleProcess.Instance == null)
            {
                KillCurrentProcess("SimpleProcess init failed");
                return;
            }

            if (PackDispatch.Instance == null)
            {
                KillCurrentProcess("PackDispatch init failed");
                return;
            }
        }

        private void KillCurrentProcess(string logContext)
        {
            System.Windows.Forms.MessageBox.Show(logContext);
            System.Windows.Forms.Application.Exit();

            Process[] process = Process.GetProcesses();
            Process currentProcess = Process.GetCurrentProcess();
            for (int idx = 0; idx < process.Count(); idx++)
            {
                if (process[idx].ProcessName == currentProcess.ProcessName)
                {
                    process[idx].Kill();
                }
            }
            return;
        }
    }
}
