﻿using ProjectManagementSystem.Common.Dispatch;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectManagementSystem.UI
{
    public partial class DebugPackRgvUI : UserControl, IDisplayUI
    {
        public DebugPackRgvUI()
        {
            InitializeComponent();
        }

        public bool Init()
        {
            dataGridUI1.dataGridView1.CellClick += DataGridView1_CellClick;
            return true;
        }

        private void DataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            textBox1.Text = dataGridUI1.GetCurrentColValue("Id");
        }

        public void UpdateDisplay()
        {
            if (!this.Visible) return;

            this.Invoke(new MethodInvoker(() =>
            {
                this.label2.Text = $"{PackDispatch.Instance.TimeConsumption} ms";
            }));

            var dataList = PackDispatch.Instance.StationDictionary.Values.OrderBy(d => d.Id).ToList();
            dataGridUI1.ShowDataGrid(dataList, (s, v) => s.Id == v.Id);
        }




    }
}
