﻿using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Dispatch;
using ProjectManagementSystem.Language;
using ProjectManagementSystem.WebApi.Service;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace ProjectManagementSystemView.Entrance
{
    public class DispatchSystem
    {
        public DispatchSystem()
        {
            if (ExcelConfig.Instance == null)
            {
                KillCurrentProcess(Langs.InitFailExcelConfig);
                return;
            }

            if (!SystemInitialize.InitDataSource())
            {
                KillCurrentProcess(Langs.InitFailDataSource);
                return;
            }

            //if (RouteCalled.Instance == null)
            //{
            //    KillCurrentProcess(Langs.InitFailRouteCalled);
            //    return;
            //}

            if (PlcControl.Instance == null)
            {
                KillCurrentProcess(Langs.InitFailPlcControl);
                return;
            }

            if (DeviceControl.Instance == null)
            {
                KillCurrentProcess(Langs.InitFailDeviceControl);
                return;
            }

            if (!WebApiServerHost.Instance.StartServer())
            {
                KillCurrentProcess(Langs.InitFailWebApi);
                return;
            }

            SystemInitialize.InitWMS();

            if (SimpleProcess.Instance == null)
            {
                KillCurrentProcess("SimpleProcess init failed");
                return;
            }

            if (PackDispatch.Instance == null)
            {
                KillCurrentProcess("PackDispatch init failed");
                return;
            }
        }

        private void KillCurrentProcess(string logContext)
        {
            MessageBox.Show(logContext);
            Application.Current.Shutdown();

            Process[] process = Process.GetProcesses();
            Process currentProcess = Process.GetCurrentProcess();
            for (int idx = 0; idx < process.Count(); idx++)
            {
                if (process[idx].ProcessName == currentProcess.ProcessName)
                {
                    process[idx].Kill();
                }
            }
            return;
        }
    }
}
