﻿using ProjectManagementSystem.Language;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystemView.Infrastructure.Helpers
{
    public class ResourceProvider : INotifyPropertyChanged
    {
        private Langs resources;
        public Langs Langs => resources;


        public event PropertyChangedEventHandler PropertyChanged;
        private void RaisePropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        public ResourceProvider()
        {
            resources = ResourceService.Current.Langs;
            ResourceService.Current.CultureChanged += d => RaisePropertyChanged("");
        }
    }
}
