﻿using PropertyChanged;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media.Media3D;

namespace ProjectManagementSystemView.Infrastructure.Models
{
    [AddINotifyPropertyChangedInterface]
    public class VmResultAgvData
    {
        public int AgvID { get; set; }
        public int Status { get; set; }
        public string OrderID { get; set; }
        public double MovementX { get; set; }
        public double MovementY { get; set; }
        public double MovementAttitude { get; set; }
        public bool? TrafficBlocked { get; set; }
        public int BatteryLevel { get; set; }
        public int GraphVertex { get; set; }
        public int GraphEdge { get; set; }
        public double GraphOffset { get; set; }
        public bool Online { get; set; }
        public int CarrierType { get; set; }
        public ushort LogicBits { get; set; }


        public double CX => MovementX / 1000.0;
        public double CY => MovementY / 1000.0;
        public double CZ => 1.6;
    }
}
