﻿using DbCommon.BusinessCore.BaseCore;
using DbCommon.Enties.DbModels;
using Prism.Events;
using ProjectManagementSystemView.Infrastructure.Events;
using ProjectManagementSystemView.Infrastructure.Extensions;
using ProjectManagementSystemView.Infrastructure.Models;
using PropertyChanged;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystemView.ViewModels
{
    [AddINotifyPropertyChangedInterface]
    public class CallTaskViewModel
    {
        private CallTaskManager callTaskManager = new CallTaskManager();

        public bool IsVisible { get; set; }
        public ObservableCollection<VmCallTask> VmDatas { get; set; } = new ObservableCollection<VmCallTask>();
        public CallTaskViewModel(IEventAggregator eventAggregator)
        {
            eventAggregator.GetEvent<UpdateViewEvent>().Subscribe(UpdateView);
        }

        private void UpdateView()
        {
            if (!IsVisible) return;

            var dataList = callTaskManager.GetList(d => d.TaskStatus < EnumTaskStatus.任务完成);

            VmDatas.Update(dataList, (s, v) => s.TaskID == v.TaskID);
        }
    }
}
