﻿using Prism.Events;
using ProjectManagementSystemView.Infrastructure.Events;
using ProjectManagementSystemView.Infrastructure.Extensions;
using ProjectManagementSystemView.Infrastructure.Models;
using PropertyChanged;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystemView.ViewModels
{
    [AddINotifyPropertyChangedInterface]
    public class DebugAgvViewModel
    {
        public bool IsVisible { get; set; }
        public ObservableCollection<VmResultAgvData> VmDatas { get; set; } = new ObservableCollection<VmResultAgvData>();
        public DebugAgvViewModel(IEventAggregator eventAggregator)
        {
            eventAggregator.GetEvent<UpdateViewEvent>().Subscribe(UpdateView);
        }

        private void UpdateView()
        {
            if (!IsVisible) return;

            var agvDataList = ProjectManagementSystem.Common.Service.Crms.PmsApi.GetAllCarrier();

            VmDatas.Update(agvDataList, (s, v) => s.AgvID == v.AgvID);
        }
    }
}
